<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>jetset.mcmc &#8212; jetset 1.0.a documentation</title>
    <link rel="stylesheet" href="../../_static/bootstrap-sphinx.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../../',
        VERSION:     '1.0.a',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true,
        SOURCELINK_SUFFIX: '.txt'
      };
    </script>
    <script type="text/javascript" src="../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../_static/doctools.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.1/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
    <script type="text/javascript" src="../../_static/js/jquery-1.11.0.min.js"></script>
    <script type="text/javascript" src="../../_static/js/jquery-fix.js"></script>
    <script type="text/javascript" src="../../_static/bootstrap-3.3.7/js/bootstrap.min.js"></script>
    <script type="text/javascript" src="../../_static/bootstrap-sphinx.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
<meta charset='utf-8'>
<meta http-equiv='X-UA-Compatible' content='IE=edge,chrome=1'>
<meta name='viewport' content='width=device-width, initial-scale=1.0, maximum-scale=1'>
<meta name="apple-mobile-web-app-capable" content="yes">

  </head>
  <body>

  <div id="navbar" class="navbar navbar-inverse navbar-default navbar-fixed-top">
    <div class="container">
      <div class="navbar-header">
        <!-- .btn-navbar is used as the toggle for collapsed navbar content -->
        <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".nav-collapse">
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
        </button>
        <a class="navbar-brand" href="../../index.html"><span><img src="../../_static/logo_small_transp.png"></span>
          JetSeT</a>
        <span class="navbar-text navbar-version pull-left"><b>1.0</b></span>
      </div>

        <div class="collapse navbar-collapse nav-collapse">
          <ul class="nav navbar-nav">
            
            
              <li class="dropdown globaltoc-container">
  <a role="button"
     id="dLabelGlobalToc"
     data-toggle="dropdown"
     data-target="#"
     href="../../index.html">JetSeT <b class="caret"></b></a>
  <ul class="dropdown-menu globaltoc"
      role="menu"
      aria-labelledby="dLabelGlobalToc"><ul>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/user_guide.html">user guide</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../user_guide/user_guide.html#content">Content</a></li>
</ul>
</li>
</ul>
</ul>
</li>
              
                <li class="dropdown">
  <a role="button"
     id="dLabelLocalToc"
     data-toggle="dropdown"
     data-target="#"
     href="#">Page <b class="caret"></b></a>
  <ul class="dropdown-menu localtoc"
      role="menu"
      aria-labelledby="dLabelLocalToc"></ul>
</li>
              
            
            
              
                
              
            
            
            
            
              <li class="hidden-sm"></li>
            
          </ul>

          
            
<form class="navbar-form navbar-right" action="../../search.html" method="get">
 <div class="form-group">
  <input type="text" name="q" class="form-control" placeholder="Search" />
 </div>
  <input type="hidden" name="check_keywords" value="yes" />
  <input type="hidden" name="area" value="default" />
</form>
          
        </div>
    </div>
  </div>

<div class="container">
  <div class="row">
      <div class="col-md-3">
        <div id="sidebar" class="bs-sidenav" role="complementary">
<form action="../../search.html" method="get">
 <div class="form-group">
  <input type="text" name="q" class="form-control" placeholder="Search" />
 </div>
  <input type="hidden" name="check_keywords" value="yes" />
  <input type="hidden" name="area" value="default" />
</form>
        </div>
      </div>
    <div class="col-md-9 content">
      
  <h1>Source code for jetset.mcmc</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">__future__</span> <span class="k">import</span> <span class="n">absolute_import</span><span class="p">,</span> <span class="n">division</span><span class="p">,</span> <span class="n">print_function</span>

<span class="kn">from</span> <span class="nn">builtins</span> <span class="k">import</span> <span class="p">(</span><span class="nb">bytes</span><span class="p">,</span> <span class="nb">str</span><span class="p">,</span> <span class="nb">open</span><span class="p">,</span> <span class="nb">super</span><span class="p">,</span> <span class="nb">range</span><span class="p">,</span>
                      <span class="nb">zip</span><span class="p">,</span> <span class="nb">round</span><span class="p">,</span> <span class="nb">input</span><span class="p">,</span> <span class="nb">int</span><span class="p">,</span> <span class="nb">pow</span><span class="p">,</span> <span class="nb">object</span><span class="p">,</span> <span class="nb">map</span><span class="p">,</span> <span class="nb">zip</span><span class="p">)</span>

<span class="n">__author__</span> <span class="o">=</span> <span class="s2">&quot;Andrea Tramacere&quot;</span>

<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">scipy</span> <span class="k">as</span> <span class="nn">sp</span>
<span class="kn">from</span> <span class="nn">scipy</span> <span class="k">import</span> <span class="n">stats</span>


<span class="n">__all__</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;MCMC&#39;</span><span class="p">]</span>
<div class="viewcode-block" id="MCMC"><a class="viewcode-back" href="../../api/jetset.mcmc.MCMC.html#jetset.mcmc.MCMC">[docs]</a><span class="k">class</span> <span class="nc">MCMC</span> <span class="p">(</span><span class="nb">object</span><span class="p">):</span>

    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">fit_par</span><span class="p">,</span><span class="n">range_rel</span><span class="p">,</span><span class="n">range_sigma</span><span class="p">,</span><span class="n">jump_step_rel</span><span class="p">,</span><span class="n">jump_step_sigma</span><span class="p">,</span><span class="n">proposal</span><span class="o">=</span><span class="s1">&#39;uniform&#39;</span><span class="p">):</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">burn_in_size</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">trials_size</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">fit_par</span><span class="o">=</span><span class="n">fit_par</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">par_range</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">jump_step</span>
        
        <span class="k">if</span> <span class="n">proposal</span><span class="o">==</span><span class="s1">&#39;uniform&#39;</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">proposal_prob</span><span class="o">=</span><span class="n">stats</span><span class="o">.</span><span class="n">uniform</span><span class="o">.</span><span class="n">pdf</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">proposal_val</span><span class="o">=</span><span class="n">stats</span><span class="o">.</span><span class="n">uniform</span><span class="o">.</span><span class="n">rvs</span>
        <span class="k">elif</span> <span class="n">proposal</span><span class="o">==</span><span class="s1">&#39;normal&#39;</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">proposal_prob</span><span class="o">=</span><span class="n">stats</span><span class="o">.</span><span class="n">norm</span><span class="o">.</span><span class="n">pdf</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">proposal_val</span><span class="o">=</span><span class="n">stats</span><span class="o">.</span><span class="n">norm</span><span class="o">.</span><span class="n">rvs</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="nb">print</span> <span class="p">(</span><span class="s2">&quot;proposal distribution not in allowed&quot;</span><span class="p">)</span>
            
            <span class="k">return</span>     
        
    
    
<div class="viewcode-block" id="MCMC.run"><a class="viewcode-back" href="../../api/jetset.mcmc.MCMC.html#jetset.mcmc.MCMC.run">[docs]</a>    <span class="k">def</span> <span class="nf">run</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        
        <span class="n">LEN</span><span class="o">=</span><span class="mi">0</span>
        
        <span class="n">TRIAL</span><span class="o">=</span><span class="mi">0</span>

        <span class="n">oldLike</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">func_stat</span><span class="p">()</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">init_par</span><span class="p">()</span>
        
        <span class="k">while</span> <span class="n">TRIAL</span> <span class="o">&lt;=</span><span class="bp">self</span><span class="o">.</span><span class="n">MCMC_TRIALS</span> <span class="ow">and</span> <span class="n">LEN</span><span class="o">&lt;</span><span class="bp">self</span><span class="o">.</span><span class="n">Lenght</span><span class="p">:</span>
            
            <span class="n">TRIAL</span><span class="o">+=</span><span class="mi">1</span>
                       
            <span class="c1">#Draw parameters </span>
            <span class="bp">self</span><span class="o">.</span><span class="n">random_walk</span><span class="p">()</span>
          
            <span class="bp">self</span><span class="o">.</span><span class="n">update_prior</span><span class="p">()</span>
        
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">prior21</span><span class="o">&gt;</span><span class="mi">0</span><span class="p">:</span>
                
                <span class="bp">self</span><span class="o">.</span><span class="n">UpdatePrefac</span><span class="p">()</span>
        
                <span class="n">newLike</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">func_stat</span><span class="p">()</span>
        
                <span class="n">ratio</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">exp</span><span class="p">(</span><span class="n">newLike</span><span class="o">-</span><span class="n">oldLike</span><span class="p">)</span><span class="o">*</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Prefac</span><span class="p">)</span>
                
                <span class="n">aprob</span><span class="o">=</span><span class="nb">min</span><span class="p">([</span><span class="mf">1.0</span><span class="p">,</span><span class="n">ratio</span><span class="p">])</span>
        
                <span class="n">u</span> <span class="o">=</span> <span class="n">stats</span><span class="o">.</span><span class="n">uniform</span><span class="o">.</span><span class="n">rvs</span><span class="p">(</span><span class="n">loc</span><span class="o">=</span><span class="mf">0.0</span><span class="p">,</span><span class="n">scale</span><span class="o">=</span><span class="mf">1.0</span><span class="p">)</span>
      
                <span class="c1">#Decide trial acceptance</span>
                <span class="k">if</span>  <span class="n">u</span> <span class="o">&lt;</span> <span class="n">aprob</span><span class="p">:</span>
                    <span class="n">LEN</span><span class="o">+=</span><span class="mi">1</span>
                    <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;TRIAL=</span><span class="si">%d</span><span class="s2"> accetto ratio=</span><span class="si">%e</span><span class="s2"> u=</span><span class="si">%e</span><span class="s2"> par[1]=</span><span class="si">%s</span><span class="s2"> -LogLike=</span><span class="si">%e</span><span class="s2"> &quot;</span><span class="o">%</span><span class="p">(</span><span class="n">TRIAL</span><span class="p">,</span><span class="n">ratio</span><span class="p">,</span><span class="n">u</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">par</span><span class="p">[</span><span class="mi">1</span><span class="p">],</span><span class="o">-</span><span class="n">newLike</span><span class="p">))</span>
                    <span class="n">oldLike</span><span class="o">=</span><span class="n">newLike</span></div>
          
    
<div class="viewcode-block" id="MCMC.init_MCMC_pars"><a class="viewcode-back" href="../../api/jetset.mcmc.MCMC.html#jetset.mcmc.MCMC.init_MCMC_pars">[docs]</a>    <span class="k">def</span> <span class="nf">init_MCMC_pars</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">for</span> <span class="n">pi</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">fit_par</span><span class="p">)):</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">fit_par</span><span class="p">[</span><span class="n">pi</span><span class="p">]</span><span class="o">.</span><span class="n">err</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">delta_par</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">fit_par</span><span class="p">[</span><span class="n">pi</span><span class="p">]</span><span class="o">.</span><span class="n">err</span><span class="o">*</span><span class="bp">self</span><span class="o">.</span><span class="n">range_sigma</span>
                <span class="n">step_par</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">fit_par</span><span class="p">[</span><span class="n">pi</span><span class="p">]</span><span class="o">.</span><span class="n">err</span><span class="o">*</span><span class="bp">self</span><span class="o">.</span><span class="n">jump_step_sigma</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">delta_par</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">fit_par</span><span class="p">[</span><span class="n">pi</span><span class="p">]</span><span class="o">.</span><span class="n">val</span><span class="o">*</span><span class="bp">self</span><span class="o">.</span><span class="n">range_rel</span>
                <span class="n">step_par</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">fit_par</span><span class="p">[</span><span class="n">pi</span><span class="p">]</span><span class="o">.</span><span class="n">val</span><span class="o">*</span><span class="bp">self</span><span class="o">.</span><span class="n">jump_step_rel</span>
                
            <span class="bp">self</span><span class="o">.</span><span class="n">fit_par</span><span class="p">[</span><span class="n">pi</span><span class="p">]</span><span class="o">.</span><span class="n">MCMC_range_min</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">fit_par</span><span class="p">[</span><span class="n">pi</span><span class="p">]</span><span class="o">.</span><span class="n">val</span> <span class="o">-</span> <span class="n">delta_par</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">fit_par</span><span class="p">[</span><span class="n">pi</span><span class="p">]</span><span class="o">.</span><span class="n">MCMC_range_max</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">fit_par</span><span class="p">[</span><span class="n">pi</span><span class="p">]</span><span class="o">.</span><span class="n">val</span> <span class="o">+</span> <span class="n">delta_par</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">fit_par</span><span class="p">[</span><span class="n">pi</span><span class="p">]</span><span class="o">.</span><span class="n">MCMC_jump_step</span><span class="o">=</span><span class="n">step_par</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">fit_par</span><span class="p">[</span><span class="n">pi</span><span class="p">]</span><span class="o">.</span><span class="n">MCMC_val</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">fit_par</span><span class="p">[</span><span class="n">pi</span><span class="p">]</span><span class="o">.</span><span class="n">val</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">fit_par</span><span class="p">[</span><span class="n">pi</span><span class="p">]</span><span class="o">.</span><span class="n">MCMC_trial</span><span class="o">=</span><span class="kc">None</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">fit_par</span><span class="p">[</span><span class="n">pi</span><span class="p">]</span><span class="o">.</span><span class="n">MCMC_sample</span><span class="o">=</span><span class="n">sp</span><span class="o">.</span><span class="n">zeros</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">trials_size</span><span class="p">)</span></div>
    
    
<div class="viewcode-block" id="MCMC.random_walk"><a class="viewcode-back" href="../../api/jetset.mcmc.MCMC.html#jetset.mcmc.MCMC.random_walk">[docs]</a>    <span class="k">def</span> <span class="nf">random_walk</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">size</span><span class="p">):</span>
        <span class="k">for</span> <span class="n">pi</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">fit_par</span><span class="p">)):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">fit_par</span><span class="p">[</span><span class="n">pi</span><span class="p">]</span><span class="o">.</span><span class="n">MCMC_trial</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">draw_proposal</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">parfit_par</span><span class="p">[</span><span class="n">pi</span><span class="p">])</span></div>
           

            
<div class="viewcode-block" id="MCMC.draw_proposal"><a class="viewcode-back" href="../../api/jetset.mcmc.MCMC.html#jetset.mcmc.MCMC.draw_proposal">[docs]</a>    <span class="k">def</span> <span class="nf">draw_proposal</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">par</span><span class="p">):</span>
        <span class="n">loc</span><span class="o">=</span><span class="n">par</span><span class="o">.</span><span class="n">MCMC_range_min</span>
        <span class="n">scale</span><span class="o">=</span><span class="n">par</span><span class="o">.</span><span class="n">MCMC_range_max</span><span class="o">-</span><span class="n">par</span><span class="o">.</span><span class="n">MCMC_range_min</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">proposal_val</span><span class="p">(</span><span class="n">loc</span><span class="o">=</span><span class="n">loc</span><span class="p">,</span><span class="n">scale</span><span class="o">=</span><span class="n">scale</span><span class="p">)</span></div>
    
    
<div class="viewcode-block" id="MCMC.update_prior"><a class="viewcode-back" href="../../api/jetset.mcmc.MCMC.html#jetset.mcmc.MCMC.update_prior">[docs]</a>    <span class="k">def</span> <span class="nf">update_prior</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
       
        <span class="bp">self</span><span class="o">.</span><span class="n">prior12</span><span class="o">=</span><span class="mi">1</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">prior21</span><span class="o">=</span><span class="mi">1</span>
        
        <span class="k">for</span> <span class="n">pi</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">fit_par</span><span class="p">)):</span>
    
            <span class="bp">self</span><span class="o">.</span><span class="n">prior12</span> <span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">prior12</span> <span class="o">*</span> <span class="bp">self</span><span class="o">.</span><span class="n">prior_fact</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">fit_par</span><span class="p">[</span><span class="n">pi</span><span class="p">],</span><span class="bp">self</span><span class="o">.</span><span class="n">fit_par</span><span class="p">[</span><span class="n">pi</span><span class="p">]</span><span class="o">.</span><span class="n">MCMC_val</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">fit_par</span><span class="p">[</span><span class="n">pi</span><span class="p">]</span><span class="o">.</span><span class="n">MCMC_trial</span><span class="p">)</span>

            <span class="bp">self</span><span class="o">.</span><span class="n">prior21</span> <span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">prior21</span> <span class="o">*</span> <span class="bp">self</span><span class="o">.</span><span class="n">prior_fact</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">fit_par</span><span class="p">[</span><span class="n">pi</span><span class="p">],</span><span class="bp">self</span><span class="o">.</span><span class="n">fit_par</span><span class="p">[</span><span class="n">pi</span><span class="p">]</span><span class="o">.</span><span class="n">MCMC_trial</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">fit_par</span><span class="p">[</span><span class="n">pi</span><span class="p">]</span><span class="o">.</span><span class="n">MCMC_val</span><span class="p">)</span>    </div>
    
    
<div class="viewcode-block" id="MCMC.prior_fact"><a class="viewcode-back" href="../../api/jetset.mcmc.MCMC.html#jetset.mcmc.MCMC.prior_fact">[docs]</a>    <span class="k">def</span> <span class="nf">prior_fact</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">_prime</span><span class="p">,</span><span class="n">x</span><span class="p">,</span><span class="n">scale</span><span class="p">):</span>
        
        <span class="n">loc</span><span class="o">=</span><span class="n">par</span><span class="o">.</span><span class="n">MCMC_range_min</span>
        <span class="n">scale</span><span class="o">=</span><span class="n">par</span><span class="o">.</span><span class="n">MCMC_range_max</span><span class="o">-</span><span class="n">par</span><span class="o">.</span><span class="n">MCMC_range_min</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">proposal_prob</span><span class="p">(</span><span class="n">x</span><span class="p">,</span><span class="n">loc</span><span class="o">=</span><span class="n">loc</span><span class="p">,</span><span class="n">scale</span><span class="o">=</span><span class="n">scale</span><span class="p">)</span> </div></div>
</pre></div>

    </div>
      
  </div>
</div>
<footer class="footer">
  <div class="container">
    <p class="pull-right">
      <a href="#">Back to top</a>
      
    </p>
    <p>
        &copy; Copyright 2018, andrea tramacere.<br/>
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.6.6.<br/>
    </p>
  </div>
</footer>
  </body>
</html>